//
//  AppDelegate.m
//  ObjViewer
//
//  Created by song on 2013-01-21.
//  Copyright (c) 2013 song. All rights reserved.
//

#import "AppDelegate.h"
#import <string>
#import "BoundingBox.h"



@implementation AppDelegate
@synthesize panelAbout;
@synthesize viewGL;
@synthesize buttonLoad;
@synthesize buttonAbout;
@synthesize tabView;
@synthesize tabItemView1;
@synthesize tabItemView2;
@synthesize tabItemView3;
@synthesize spinnerLoading;

// tabItemView 1
@synthesize checkGrid;
@synthesize checkWireframe;
@synthesize checkBoundingBox;
@synthesize checkTextures;
@synthesize checkDefaultTexture;
@synthesize checkBlackBackground;
@synthesize sliderAmbient;
@synthesize sliderDiffuse;
@synthesize sliderSpecular;
@synthesize labelAmbient;
@synthesize labelDiffuse;
@synthesize labelSpecular;
@synthesize sliderLightX;
@synthesize sliderLightY;
@synthesize sliderLightZ;
@synthesize labelLightX;
@synthesize labelLightY;
@synthesize labelLightZ;
@synthesize comboScreenshot;
@synthesize textScreenshot;
@synthesize buttonUp;
@synthesize buttonDown;
@synthesize buttonLeft;
@synthesize buttonRight;

// tabItemView 2
@synthesize textObjName;
@synthesize textMtlName;
@synthesize textTexName;
@synthesize textWidth;
@synthesize textHeight;
@synthesize textDepth;
@synthesize labelWidth;
@synthesize labelHeight;
@synthesize labelDepth;
@synthesize textArea;
@synthesize labelCenter;
@synthesize textTriangleCount;
@synthesize textIndexCount;
@synthesize textVertexCount;
@synthesize textTexCoordCount;
@synthesize tableGroups;
@synthesize groupNames;

// tabItemView 3
@synthesize stepPositionX;
@synthesize stepPositionY;
@synthesize stepPositionZ;
@synthesize textPositionX;
@synthesize textPositionY;
@synthesize textPositionZ;
@synthesize stepRotationX;
@synthesize stepRotationY;
@synthesize stepRotationZ;
@synthesize textRotationX;
@synthesize textRotationY;
@synthesize textRotationZ;
@synthesize stepScaleX;
@synthesize stepScaleY;
@synthesize stepScaleZ;
@synthesize textScaleX;
@synthesize textScaleY;
@synthesize textScaleZ;
@synthesize textSaveObj;



///////////////////////////////////////////////////////////////////////////////
- (void)applicationWillFinishLaunching:(NSNotification *)notification
{
    printf("===== Application will be launched. =====\n");

    // ViewGL is available at this moment
    // tell view component which model component is
    // NOTE: Must init OpenGL states in prepareOpenGL
    [viewGL setModel:&model];
}



///////////////////////////////////////////////////////////////////////////////
- (void) applicationDidFinishLaunching: (NSNotification *)aNotification
{
    printf("Application is launched from NIB.\n");

    // load system's info icon and assign it to the about button
    //[buttonAbout setImage:[NSImage imageNamed:NSImageNameInfo]];

    // configure tabview
    /*
    NSRect r = [tabView frame];
    printf("TABVIEW FRAME: (%.0f, %.0f), %.0fx%.0f\n", r.origin.x, r.origin.y, r.size.width, r.size.height);
    r = [tabView bounds];
    printf("TABVIEW BOUND: (%.0f, %.0f), %.0fx%.0f\n", r.origin.x, r.origin.y, r.size.width, r.size.height);
    r = [tabView contentRect];
    printf("TABVIEW CONTENT: (%.0f, %.0f), %.0fx%.0f\n", r.origin.x, r.origin.y, r.size.width, r.size.height);
    r = [tabItemView1 bounds];
    printf("ITEMVIEW BOUND: (%.0f, %.0f), %.0fx%.0f\n", r.origin.x, r.origin.y, r.size.width, r.size.height);
    */
    [[tabView tabViewItemAtIndex:0] setView:tabItemView1];
    [[tabView tabViewItemAtIndex:1] setView:tabItemView2];
    [[tabView tabViewItemAtIndex:2] setView:tabItemView3];

    // init UIs
    [comboScreenshot selectItemAtIndex:1];  // 0=1024, 1=2048, 2=4096, 3=8192
    [buttonUp sendActionOn: NSEventMaskLeftMouseDown | NSEventMaskLeftMouseUp | NSEventMaskLeftMouseDragged];
    [buttonDown sendActionOn: NSEventMaskLeftMouseDown | NSEventMaskLeftMouseUp | NSEventMaskLeftMouseDragged];
    [buttonLeft sendActionOn: NSEventMaskLeftMouseDown | NSEventMaskLeftMouseUp | NSEventMaskLeftMouseDragged];
    [buttonRight sendActionOn: NSEventMaskLeftMouseDown | NSEventMaskLeftMouseUp | NSEventMaskLeftMouseDragged];

    // bind opengl context
    [viewGL.openGLContext makeCurrentContext];

    // tell view component which model component is
    //[viewGL setModel:&model];

    // OpenGL RC (Rendering Context) should be ready at this point
    // init OpenGL states here
    model.init();
    printf("Initialized OpenGL states.\n");

    // get size of opengl window, and pass it to model component
    NSRect rect = [viewGL convertRectToBacking:[viewGL bounds]];
    model.setWindowSize((int)rect.size.width, (int)rect.size.height);

    NSBundle* bundle = [NSBundle mainBundle];

    // load default texture
    std::string defaultTex = [[bundle pathForResource:@"grid512" ofType:@"png"] UTF8String];
    //printf("Loading the default texture: %s...\n", defaultTex.c_str());
    model.loadDefaultTexture(defaultTex.c_str());

    // light and material
    [self resetMaterial:nil];
    [self resetLight:nil];

    // callback for loading OBJ
    // NOTE: Obj-C has a different calling convention than C/C++.
    // The 1st param must be the instance of obj, and the 2nd param is the
    // selector of Obj-C method before the rest of arguments.
    // typedef void (*IMP)(id, SEL, args...)
    // It is possible to get the pointer of Obj-C method using @selector, and
    // to call it from C/C++ as callback. However, it cannot use the associated
    // parameter due to different calling convention with extra arguments (id, SEL).
    SEL sel = @selector(callbackObjLoaded);         // get function(method) identifier
    IMP imp = [self methodForSelector:sel];         // get function(method) pointer
    CallbackResult callback = (CallbackResult)imp;  // cast it function ptr

    // build default obj file path and load it
    std::string defaultObj = [[bundle pathForResource:@"cube_tris" ofType:@"obj"] UTF8String];
    printf("Loading the default OBJ: %s...\n", defaultObj.c_str());

    timer.start();
    model.startLoadObj(defaultObj, callback, (__bridge void*)self);

    //model.startLoadObj(defaultObj, callback);
    /*
    if(result)
    {
        [self setDescription];
        printf("Loaded the default OBJ model.\n");
    }
    else
    {
        [self clearDescription];
        printf("[ERROR] Failed to open the default OBJ model.");
    }
    */

    // release opengl context
    //printf("Releasing OpenGL context\n");
    [NSOpenGLContext clearCurrentContext];

    // start opengl rendering loop
    [viewGL startRenderingLoop];
}



///////////////////////////////////////////////////////////////////////////////
- (void) awakeFromNib
{
    //printf("awakeFromNib\n");
}



///////////////////////////////////////////////////////////////////////////////
- (void) applicationWillTerminate: (NSNotification*)notification
{
    printf("Application is terminated\n");
}



///////////////////////////////////////////////////////////////////////////////
- (BOOL) applicationShouldTerminateAfterLastWindowClosed: (NSApplication*) application
{
    //printf("applicationShouldTerminateAfterLastWindowClosed\n");
    // terminate app
    return YES;
}



///////////////////////////////////////////////////////////////////////////////
// delegage for tabview
- (void)tabView:(NSTabView*)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem
{
    //printf("didSelectTabViewItem\n");
    //tabViewItem v
}



///////////////////////////////////////////////////////////////////////////////
// load new OBJ file
- (IBAction) loadObj: (id)sender
{
    // create NSOpenPanel
    NSOpenPanel* panel = [NSOpenPanel openPanel];

    // set options
    NSArray* fileTypes = [NSArray arrayWithObjects:@"obj", nil];
    [panel setAllowedFileTypes:fileTypes];
    [panel setCanChooseFiles:YES];

    // show indicator (hide in callbackObjLoaded)
    [spinnerLoading setHidden:FALSE];
    [spinnerLoading startAnimation:self];

    // load obj
    if([panel runModal] == NSOKButton)
    {
        NSString* fullpath = [[[panel URLs] objectAtIndex:0] path];

        // start timer (stop it in callbackObjLoaded)
        timer.start();

        // load a OBJ
        SEL sel = @selector(callbackObjLoaded);         // get function(method) identifier
        IMP imp = [self methodForSelector:sel];         // get function(method) pointer
        CallbackResult callback = (CallbackResult)imp;  // cast it function ptr
        model.startLoadObj([fullpath UTF8String], callback, (__bridge void*)self);
        printf("Loading a OBJ: %s...\n", [fullpath UTF8String]);

        /*
        bool result = model.loadObj([fullpath UTF8String]);
        if(result)
        {
            [self setDescription];
            printf("Loaded OBJ: %s.\n", [fullpath UTF8String]);
        }
        else
        {
            [self clearDescription];
            printf("[ERROR] Failed to load %s\n", [fullpath UTF8String]);
        }
        timer.stop();
        printf("Elapsed Time: %f ms.\n", timer.getElapsedTimeInMilliSec());

        [viewGL setNeedsDisplay:TRUE];
        */
    }
    else
    {
        [spinnerLoading setHidden:YES];
        [spinnerLoading stopAnimation:self];
    }
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction) showAbout: (id)sender
{
    [NSApp runModalForWindow: panelAbout];
}
- (IBAction) closeAbout: (id)sender
{
    [NSApp stopModal];
    [panelAbout close];
}



///////////////////////////////////////////////////////////////////////////////
// set drawing options
- (IBAction) handleOption: (id)sender
{
    if(sender == checkGrid)
    {
        if([sender state] == NSOnState)
            model.enableGrid();
        else
            model.disableGrid();
    }
    else if(sender == checkTextures)
    {
        if([sender state] == NSOnState)
            model.enableTexture();
        else
            model.disableTexture();
    }
    else if(sender == checkWireframe)
    {
        if([sender state] == NSOnState)
            model.enableWireframe();
        else
            model.disableWireframe();
    }
    else if(sender == checkDefaultTexture)
    {
        if([sender state] == NSOnState)
        {
            model.enableDefaultTexture();
        }
        else
        {
            model.disableDefaultTexture();
        }
    }
    else if(sender == checkBoundingBox)
    {
        if([sender state] == NSOnState)
            model.enableBoundingBox();
        else
            model.disableBoundingBox();
    }
    else if(sender == checkBlackBackground)
    {
        if([sender state] == NSOnState)
        {
            model.enableBlackBackground();
        }
        else
        {
            model.disableBlackBackground();
        }
    }
    [viewGL setNeedsDisplay:YES];
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)resetMaterial:(id)sender
{
    model.resetMaterial();
    [sliderAmbient setFloatValue:model.getAmbient()];
    [sliderDiffuse setFloatValue:model.getDiffuse()];
    [sliderSpecular setFloatValue:model.getSpecular()];
    [labelAmbient setStringValue:[NSString stringWithFormat:@"%.1f", model.getAmbient()]];
    [labelDiffuse setStringValue:[NSString stringWithFormat:@"%.1f", model.getDiffuse()]];
    [labelSpecular setStringValue:[NSString stringWithFormat:@"%.1f", model.getSpecular()]];
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)resetLight:(id)sender
{
    model.resetLightPosition();
    [sliderLightX setFloatValue:model.getLightPositionX()];
    [sliderLightY setFloatValue:model.getLightPositionY()];
    [sliderLightZ setFloatValue:model.getLightPositionZ()];
    [labelLightX setStringValue:[NSString stringWithFormat:@"%.1f", model.getLightPositionX()]];
    [labelLightY setStringValue:[NSString stringWithFormat:@"%.1f", model.getLightPositionY()]];
    [labelLightZ setStringValue:[NSString stringWithFormat:@"%.1f", model.getLightPositionZ()]];
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)updateMaterial:(NSSlider *)sender
{
    float value = sender.floatValue;
    NSString* valueString = [NSString stringWithFormat:@"%.1f", value];

    if(sender == sliderAmbient)
    {
        [labelAmbient setStringValue:valueString];
        model.setAmbient(value);
    }
    else if(sender == sliderDiffuse)
    {
        [labelDiffuse setStringValue:valueString];
        model.setDiffuse(value);
    }
    else if(sender == sliderSpecular)
    {
        [labelSpecular setStringValue:valueString];
        model.setSpecular(value);
    }
    [viewGL setNeedsDisplay:YES];
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)updateLight:(NSSlider *)sender
{
    float value = sender.floatValue;
    NSString* valueString = [NSString stringWithFormat:@"%.1f", value];

    if(sender == sliderLightX)
    {
        [labelLightX setStringValue:valueString];
        model.setLightPositionX(value);
    }
    else if(sender == sliderLightY)
    {
        [labelLightY setStringValue:valueString];
        model.setLightPositionY(value);
    }
    else if(sender == sliderLightZ)
    {
        [labelLightZ setStringValue:valueString];
        model.setLightPositionZ(value);
    }
    [viewGL setNeedsDisplay:YES];
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)saveScreenshot:(id)sender
{
    NSSavePanel* panel = [NSSavePanel savePanel];

    // set options
    [panel setTitle:@"Save Screenshot"];
    [panel setNameFieldStringValue:@"screenshot.png"];
    NSArray* fileTypes = [NSArray arrayWithObjects:@"png", nil];
    [panel setAllowedFileTypes:fileTypes];

    // show indicator (hide in callbackPngSaved)
    [spinnerLoading setHidden:FALSE];
    [spinnerLoading startAnimation:self];

    // save png
    if([panel runModal] == NSOKButton)
    {
        NSString* fullpath = [[panel URL] path];
        [textScreenshot setStringValue:fullpath];

        int size = comboScreenshot.intValue;
        model.setCaptureSize(size);

        // start timer (stop it in callbackPngSaved)
        timer.start();

        // save a screenshot
        SEL sel = @selector(callbackPngSaved);          // get function(method) identifier
        IMP imp = [self methodForSelector:sel];         // get function(method) pointer
        CallbackResult callback = (CallbackResult)imp;  // cast it function ptr
        model.startSaveImage([fullpath UTF8String], callback, (__bridge void*)self);
        printf("Saving a PNG: %s...\n", [fullpath UTF8String]);
    }
    else
    {
        [spinnerLoading setHidden:YES];
        [spinnerLoading stopAnimation:self];
    }
}



///////////////////////////////////////////////////////////////////////////////
// must set mouse down/up/dragged masks to the buttons to receive these events
- (IBAction)shiftCamera:(NSButton *)sender
{
    bool leftDown = NSEvent.pressedMouseButtons & 0x01;
    bool dragged = NSApp.currentEvent.type == NSEventTypeLeftMouseDragged;
    if(dragged || !leftDown)
    {
        model.stopShiftCamera();
        return;
    }

    if(sender == buttonLeft)
    {
        model.startShiftCamera(-1, 0);
    }
    else if(sender == buttonRight)
    {
        model.startShiftCamera(1, 0);
    }
    else if(sender == buttonUp)
    {
        model.startShiftCamera(0, 1);
    }
    else if(sender == buttonDown)
    {
        model.startShiftCamera(0, -1);
    }
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)resetCamera:(id)sender
{
    model.resetMatrices();
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)translateModel:(NSStepper *)sender
{
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)rotateModel:(NSStepper *)sender
{
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)scaleModel:(NSStepper *)sender
{
}



///////////////////////////////////////////////////////////////////////////////
// translate model
- (IBAction)translateX:(NSStepper *)sender
{
    [textPositionX setStringValue:sender.stringValue];
    model.setModelX(sender.floatValue);
}

- (IBAction)translateY:(NSStepper *)sender
{
    [textPositionY setStringValue:sender.stringValue];
    model.setModelY(sender.floatValue);
}

- (IBAction)translateZ:(NSStepper *)sender
{
    [textPositionZ setStringValue:sender.stringValue];
    model.setModelZ(sender.floatValue);
}



///////////////////////////////////////////////////////////////////////////////
// rotate model
- (IBAction)rotateX:(NSStepper *)sender
{
    [textRotationX setStringValue:sender.stringValue];
    model.setModelAngleX(sender.floatValue);
}
- (IBAction)rotateY:(NSStepper *)sender
{
    [textRotationY setStringValue:sender.stringValue];
    model.setModelAngleY(sender.floatValue);
}
- (IBAction)rotateZ:(NSStepper *)sender
{
    [textRotationZ setStringValue:sender.stringValue];
    model.setModelAngleZ(sender.floatValue);
}



///////////////////////////////////////////////////////////////////////////////
// scale model
- (IBAction)scaleX:(NSStepper *)sender
{
    [textScaleX setStringValue:sender.stringValue];
    model.setModelScaleX(sender.floatValue);
}

- (IBAction)scaleY:(NSStepper *)sender
{
    [textScaleY setStringValue:sender.stringValue];
    model.setModelScaleY(sender.floatValue);
}

- (IBAction)scaleZ:(NSStepper *)sender
{
    [textScaleZ setStringValue:sender.stringValue];
    model.setModelScaleZ(sender.floatValue);
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)resetTranslation:(id)sender
{
    [textPositionX setIntegerValue:0];
    [textPositionY setIntegerValue:0];
    [textPositionZ setIntegerValue:0];
    model.setModelX(0);
    model.setModelY(0);
    model.setModelZ(0);
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)resetRotation:(id)sender
{
    [textRotationX setIntegerValue:0];
    [textRotationY setIntegerValue:0];
    [textRotationZ setIntegerValue:0];
    model.setModelAngleX(0);
    model.setModelAngleY(0);
    model.setModelAngleZ(0);
}



///////////////////////////////////////////////////////////////////////////////
- (IBAction)resetScale:(id)sender
{
    [textScaleX setIntegerValue:1];
    [textScaleY setIntegerValue:1];
    [textScaleZ setIntegerValue:1];
    model.setModelScaleX(1);
    model.setModelScaleY(1);
    model.setModelScaleZ(1);
}



///////////////////////////////////////////////////////////////////////////////
// save the transformed model
- (IBAction)saveObj:(id)sender
{
    NSSavePanel* panel = [NSSavePanel savePanel];

    // set options
    [panel setTitle:@"Save OBJ"];
    NSArray* fileTypes = [NSArray arrayWithObjects:@"obj", nil];
    [panel setAllowedFileTypes:fileTypes];

    // show indicator (hide in callbackObjSaved)
    [spinnerLoading setHidden:FALSE];
    [spinnerLoading startAnimation:self];

    // save obj
    if([panel runModal] == NSOKButton)
    {
        NSString* fullpath = [[panel URL] path];
        [textSaveObj setStringValue:fullpath];

        // start timer (stop it in callbackObjSaved)
        timer.start();

        // save an OBJ
        SEL sel = @selector(callbackObjSaved);          // get function(method) identifier
        IMP imp = [self methodForSelector:sel];         // get function(method) pointer
        CallbackResult callback = (CallbackResult)imp;  // cast it function ptr
        model.startSaveObj([fullpath UTF8String], callback, (__bridge void*)self);
        printf("Saving an OBJ: %s...\n", [fullpath UTF8String]);
    }
    else
    {
        [spinnerLoading setHidden:YES];
        [spinnerLoading stopAnimation:self];
    }
}



///////////////////////////////////////////////////////////////////////////////
// highlight when a group is selected from the tableview
- (IBAction)handleTableRowClicked:(id)sender
{
    int index = (int)[tableGroups clickedRow];
    model.setSelectedGroup(index);
    [viewGL setNeedsDisplay:YES];
    //printf("%d\n", index);
}



///////////////////////////////////////////////////////////////////////////////
- (void) clearDescription
{
    [textObjName setStringValue:@""];
    [textMtlName setStringValue:@""];
    [textTexName setStringValue:@""];
    [textWidth setStringValue:@""];
    [textHeight setStringValue:@""];
    [textDepth setStringValue:@""];
    [labelWidth setStringValue:@""];
    [labelHeight setStringValue:@""];
    [labelDepth setStringValue:@""];
    [textArea setStringValue:@""];
    [labelCenter setStringValue:@""];
    [textTriangleCount setStringValue:@""];
    [textIndexCount setStringValue:@""];
    [textVertexCount setStringValue:@""];
    [textTexCoordCount setStringValue:@""];
    [groupNames clear];
    [tableGroups reloadData];

    [textPositionX setStringValue:@"0"];
    [textPositionY setStringValue:@"0"];
    [textPositionZ setStringValue:@"0"];
    [textRotationX setStringValue:@"0"];
    [textRotationY setStringValue:@"0"];
    [textRotationZ setStringValue:@"0"];
    [textScaleX setStringValue:@"1"];
    [textScaleY setStringValue:@"1"];
    [textScaleZ setStringValue:@"1"];
}

- (void) setDescription
{
    [textObjName setStringValue:[[NSString alloc] initWithUTF8String:model.getObjName().c_str()]];
    [textMtlName setStringValue:[[NSString alloc] initWithUTF8String:model.getMtlName().c_str()]];
    [textTexName setStringValue:[[NSString alloc] initWithUTF8String:model.getTextureName().c_str()]];
    [textTriangleCount setIntegerValue:model.getTriangleCount()];
    [textIndexCount setIntegerValue:model.getIndexCount()];
    [textVertexCount setIntegerValue:model.getVertexCount()];
    [textTexCoordCount setIntegerValue:model.getTexCoordCount()];

    const BoundingBox& bbox = model.getBoundingBox();
    [textWidth setStringValue:[NSString stringWithFormat:@"%.3f", (bbox.maxX - bbox.minX)]];
    [textHeight setStringValue:[NSString stringWithFormat:@"%.3f", (bbox.maxY - bbox.minY)]];
    [textDepth setStringValue:[NSString stringWithFormat:@"%.3f", (bbox.maxZ - bbox.minZ)]];
    [labelWidth setStringValue:[NSString stringWithFormat:@"(%.3f ~ %.3f)", bbox.minX, bbox.maxX]];
    [labelHeight setStringValue:[NSString stringWithFormat:@"(%.3f ~ %.3f)", bbox.minY, bbox.maxY]];
    [labelDepth setStringValue:[NSString stringWithFormat:@"(%.3f ~ %.3f)", bbox.minZ, bbox.maxZ]];
    [labelCenter setStringValue:[NSString stringWithFormat:@"(%.3f, %.3f, %.3f)", bbox.getCenterX(), bbox.getCenterY(), bbox.getCenterZ()]];
    [textArea setStringValue:[NSString stringWithFormat:@"%.3f", model.getSurfaceArea()]];

    [groupNames clear];
    int groupCount = (int)model.getGroupCount();
    for(int i = 0; i < groupCount; ++i)
    {
        [groupNames add:[NSString stringWithFormat:@"%d: %s", (i+1), model.getGroupName(i).c_str()]];
    }
    [tableGroups reloadData];
}



//=============================================================================
// callback for loading OBJ
// NOTE: it cannot receive parameters from the caller due to different calling
// convention
- (void) callbackObjLoaded
{
    if(model.getTriangleCount() > 0)
    {
        [self setDescription];
        [self resetTranslation:nil];
        [self resetRotation:nil];
        [self resetScale:nil];
        [[NSApp mainWindow] setTitle:[NSString stringWithFormat:@"OBJ Viewer: %s", model.getObjName().c_str()]];
        printf("Loaded a OBJ model.\n");
    }
    else
    {
        [self clearDescription];
        [self resetTranslation:nil];
        [self resetRotation:nil];
        [self resetScale:nil];
        [[NSApp mainWindow] setTitle:@"OBJ Viewer"];
        printf("[ERROR] Failed to load OBJ\n");
    }

    // hide indicator
    [spinnerLoading setHidden:YES];
    [spinnerLoading stopAnimation:self];

    [viewGL setNeedsDisplay:TRUE];

    printf("Elapsed Time: %f ms.\n", timer.getElapsedTimeInMilliSec());
}



//=============================================================================
// callback for saving OBJ
// NOTE: it cannot receive parameters from the caller due to different calling
// convention
- (void) callbackObjSaved
{
    printf("Saved an OBJ.\n");

    // hide indicator
    [spinnerLoading setHidden:YES];
    [spinnerLoading stopAnimation:self];

    printf("Elapsed Time: %f ms.\n", timer.getElapsedTimeInMilliSec());
}



//=============================================================================
// callback for saving PNG
// NOTE: it cannot receive parameters from the caller due to different calling
// convention
- (void) callbackPngSaved
{
    printf("Saved a PNG image.\n");

    // hide indicator
    [spinnerLoading setHidden:YES];
    [spinnerLoading stopAnimation:self];

    printf("Elapsed Time: %f ms.\n", timer.getElapsedTimeInMilliSec());
}


@end
