///////////////////////////////////////////////////////////////////////////////
// ViewGL.h
// ========
// View & Controller component of OpenGL window
//
//  AUTHOR: Song Ho Ahn (song.ahn@gmail.com)
// CREATED: 2013-01-22
// UPDATED: 2013-01-28
//
//  Copyright (c) 2013 Song Ho Ahn. All rights reserved.
///////////////////////////////////////////////////////////////////////////////

#import <Cocoa/Cocoa.h>
#import "ModelGL.h"


@interface ViewGL : NSOpenGLView
{
@private
    ModelGL* model;
}

@property (strong) NSTimer* timer;

- (void) setModel:(ModelGL*)m;

// for rendering loop
- (void) startRenderingLoop;
- (void) stopRenderingLoop;
- (void) loopFrames: (id)sender;


@end
